#!/bin/bash

# ɫ
CYAN="\033[1;36m"
RED="\033[0;31m"
GREEN="\033[1;32m"
RESET="\033[0m"

:<<'COMMENT'
OSSڲͰʴ洢·б
ԶʶĿ¼ļ
ͬ
COMMENT

# 屾ش洢·
LOCAL_PATH="/data/media"
mkdir -p "$LOCAL_PATH"  # ȷ·

# OSSڲͰⲿͰļ
INTERNAL_S3CFG=~/.s3cfg-internal

# ļǷ
if [ ! -f "$INTERNAL_S3CFG" ]; then
    echo -e "${RED}Internal S3 configuration file not found.${RESET}"
    exit 1
fi

# ǷOSS·
if [ $# -eq 0 ]; then
    echo -e "${RED}No OSS paths provided. Please provide OSS paths as arguments.${RESET}"
    exit 1
fi

# OSS·б
for oss_path in "$@"; do
    echo -e "${CYAN}Processing OSS path: $oss_path${RESET}"

    # ·ǷЧ
    if [[ ! $oss_path =~ ^s3:// ]]; then
        echo -e "${RED}Skipping invalid OSS path: $oss_path${RESET}"
        continue
    fi

    # ȡĿ·ı·
    local_target="$LOCAL_PATH/$(basename "$oss_path")"
    if [[ $oss_path =~ /$ ]]; then
        # Ŀ¼ȷβб
        local_target="$LOCAL_PATH/$(basename "$oss_path")/"
        mkdir -p "$local_target"  # ȷĿ¼
    fi

    # ʹ s3cmd sync ͬļĿ¼
    echo -e "${GREEN}Syncing $oss_path to local path $local_target${RESET}"
    s3cmd -c "$INTERNAL_S3CFG" sync "$oss_path" "$local_target" # | grep "Downloaded"

    if [ $? -eq 0 ]; then
        echo -e "${GREEN}Successfully synced $oss_path to $local_target${RESET}"
    else
        echo -e "${RED}Error: Failed to sync $oss_path.${RESET}"
    fi
done

echo -e "${GREEN}Script execution completed.${RESET}"